<template>
  <div id="pageCard">
    <v-container grid-list-xl fluid>
      <v-layout row wrap>
        <v-flex sm12>
          <v-card-title>
            <h4>Elección 2020</h4>
          </v-card-title>
          <v-stepper v-model="step">
            <v-stepper-header>
              <v-stepper-step step="1" :complete="step > 1">Selecciona un candidato</v-stepper-step>
              <v-divider></v-divider>
              <v-stepper-step step="2" :complete="step > 2">Listo para votar</v-stepper-step>
              <v-divider></v-divider>
            </v-stepper-header>
            <v-stepper-items>
              <v-stepper-content step="1">
                <v-radio-group v-model="candidate" :mandatory="false" row>
                  <v-flex lg4 sm12>
                    <v-card>
                      <v-card-media :src="candidato1" height="250">
                        <h2 class="white--text pa-3">Candidato 1</h2>
                      </v-card-media>
                      <v-card-text>
                        <div>{{cardText1}}</div>
                      </v-card-text>
                      <v-divider></v-divider>
                      <v-card-actions>
                        <v-radio :value="1" label="Seleccionar candidato 1" color="primary"></v-radio>
                      </v-card-actions>
                    </v-card>
                  </v-flex>
                  <v-flex lg4 sm12>
                    <v-card>
                      <v-card-media :src="candidato2" height="250">
                        <h2 class="white--text pa-3">Candidato 2</h2>
                      </v-card-media>
                      <v-card-text>
                        <div>{{cardText2}}</div>
                      </v-card-text>
                      <v-divider></v-divider>
                      <v-card-actions>
                        <v-radio :value="2" label="Seleccionar candidato 2" color="primary"></v-radio>
                      </v-card-actions>
                    </v-card>
                  </v-flex>
                  <v-flex lg4 sm12>
                    <v-card>
                      <v-card-media :src="candidato3" height="250">
                        <h2 class="white--text pa-3">Candidato 3</h2>
                      </v-card-media>
                      <v-card-text>
                        <div>{{cardText3}}</div>
                      </v-card-text>
                      <v-divider></v-divider>
                      <v-card-actions>
                        <v-radio :value="3" label="Seleccionar candidato 3" color="primary"></v-radio>
                      </v-card-actions>
                    </v-card>
                  </v-flex>
                </v-radio-group>
                <v-btn color="primary" @click="onNext">Continuar</v-btn>
              </v-stepper-content>
              <v-stepper-content step="2">
                <v-flex lg4 sm12>
                  <v-card>
                    <v-card-media :src="image" height="250">
                      <h2 class="white--text pa-3">{{name}}</h2>
                    </v-card-media>
                    <v-card-text>
                      <div>{{cardText}}</div>
                    </v-card-text>
                  </v-card>
                </v-flex>
                <v-btn color="primary" @click="onVote">Votar</v-btn>
                <v-btn flat @click="onCancel">Cancelar</v-btn>
              </v-stepper-content>
            </v-stepper-items>
          </v-stepper>
        </v-flex>
      </v-layout>
    </v-container>
    <v-snackbar v-model="snackbar.show" :timeout="3000" top right :color="snackbar.color">
      {{ snackbar.text }}
      <v-btn dark flat icon @click.native="snackbar.show = false">
        <v-icon>close</v-icon>
      </v-btn>
    </v-snackbar>
  </div>
</template>
<script>
import candidato1 from "@/assets/candidato1.jpg";
import candidato2 from "@/assets/candidato2.jpeg";
import candidato3 from "@/assets/candidato3.jpeg";
import candidateDefault from "@/assets/avatar_login.svg";

import BlockchainProvider from "@/providers/Blockchain";
const BlockchainResource = new BlockchainProvider();


export default {
  data() {
    return {
      step: 1,
      candidato1: candidato1,
      candidato2: candidato2,
      candidato3: candidato3,
      candidate: 0,
      show: true,
      name: null,
      image: candidateDefault,
      cardText1: "Votar por cadidato 1",
      cardText2: "Votar por cadidato 2",
      cardText3: "Votar por cadidato 3",
      cardText: null,
      snackbar: {
        show: false,
        text: "Debe seleccionar un candidato!",
        color: "red"
      }
    };
  },
  created() {
    // AppEvents.forEach(item => {
    //   this.$on(item.name, item.callback);
    // });
    // window.getApp = this;
  },
  computed: {},
  mounted() {
    //console.log(this.candidate);
  },
  methods: {
    onNext() {
      if (!this.candidate) {
        this.snackbar.show = true;
        return;
      } else {
        this.candidateSelected();
        this.step = 2;
      }
    },
    onCancel() {
      this.candidate = 0;
      this.step = 1;
    },
    onVote() {
      let data = {
        dni: this.$store.state.user.dni,
        data: this.$store.state.user.name,
        voto: this.candidate
      };

      BlockchainResource.mine(data)
        .then(response => {
          if (response.data) {
            this.snackbar.show = true;
            this.snackbar.color = "success";
            this.snackbar.text = "Voto exitoso!";
            this.$store
              .dispatch("VOTES")
              .then(response => {
                //window.getApp.$emit("APP_VOTES", response.data);
                this.$router.push({ name: "Dashboard" });
              })
              .catch(error => console.log(error));
          }
        })
        .catch(error => {
          this.snackbar.show = true;
          this.snackbar.text = "Ha ocurrido un error, intente más tarde!";
        });
    },
    candidateSelected() {
      switch (this.candidate) {
        case 1:
          this.name = "Candidato 1";
          this.image = this.candidato1;
          this.cardText = this.cardText1;
          break;
        case 2:
          this.name = "Candidato 2";
          this.image = this.candidato2;
          this.cardText = this.cardText2;
          break;
        case 3:
          this.name = "Candidato 3";
          this.image = this.candidato3;
          this.cardText = this.cardText2;
          break;

        default:
          break;
      }
    }
  }
};
</script>
<style lang="stylus" scoped>
.mt-45 {
  margin-top: -45px;
}

.mt-56 {
  margin-top: -56px;
}
</style>